
class FtpFileMetaDataType:
    Directory = "Directory"
    File = "File"
    Link = "Link"
    SymbolicLink = "SymbolicLink"
    CharacterDevice = "CharacterDevice"
    BlockDevice = "BlockDevice"
    Unknown = "Unknown"


class FtpFileMetaData:
    name: str
    owner: str
    group: str
    size: int
    permissions: str
    is_directory: bool
    modified: str
    hard_link_count: int
    
    def __init__(self, name: str, owner: str, group: str, size: int, permissions: str, is_directory: bool, modified: str) -> None: ...
    def get_type(self) -> FtpFileMetaDataType: ...

class FtpClient:
    def __init__(self) -> None: ...
    def connect(self, host: str = "127.0.0.1", port: int = 21, username: str = "user", password: str = "pass", timeout: int = 10, passive_mode: bool = True) -> None: ...
    def login(self, username: str, password: str) -> None: ...
    def pwd(self) -> str: ...
    def list_files(self) -> str: ...
    def list_details(self) -> list[FtpFileMetaData]: ...
    def change_directory(self, path: str) -> None: ...
    def remove_directory(self, path: str, recursive: bool = None, force: bool = None) -> None: ...
    def create_directory(self, path: str) -> None: ...
    def remove_file(self, path: str) -> None: ...
    def upload_file(self, local_path: str, remote_path: str, create_if_not_exist: bool = None) -> None: ...
    def download_file(self, remote_path: str, local_path: str) -> None: ...